<template>
  <div
    class="hidden md:absolute right-1 md:right-5 top-1 md:top-5 md:flex flex-col items-end"
  >
    <button
      id="languagePicker"
      data-dropdown-toggle="languagePickerDropdown"
      class="text-white bg-primary focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-2 md:px-4 py-1.5 md:py-2.5 text-center inline-flex items-center"
      type="button"
      @click.prevent="toggleShow"
    >
      <span class="sr-only">{{ $gettext('Change interface language') }}</span>
      <svg
        aria-hidden="true"
        width="24"
        height="24"
        stroke-width="1.5"
        viewBox="0 0 24 24"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
        class="w-8 dark:text-zinc-300"
      >
        <path
          d="M2 12C2 17.5228 6.47715 22 12 22C17.5228 22 22 17.5228 22 12C22 6.47715 17.5228 2 12 2C6.47715 2 2 6.47715 2 12Z"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
        <path
          d="M13 2.04932C13 2.04932 16 5.99994 16 11.9999C16 17.9999 13 21.9506 13 21.9506"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
        <path
          d="M11 21.9506C11 21.9506 8 17.9999 8 11.9999C8 5.99994 11 2.04932 11 2.04932"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
        <path
          d="M2.62964 15.5H21.3704"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
        <path
          d="M2.62964 8.5H21.3704"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
      </svg>
    </button>
    <div
      v-show="showMenu"
      id="languagePickerDropdown"
      class="mt-0.5 z-10 w-44 text-base list-none bg-white rounded divide-y divide-gray-100 shadow dark:bg-gray-700 dark:divide-gray-600"
      v-click-outside="() => (showMenu = false)"
    >
      <ul class="py-1" aria-labelledby="languagePicker">
        <li v-for="(lang, locale) in availableLanguages" :key="locale">
          <router-link
            :to="{ ...$route, params: { ...$route.params, locale } }"
            class="block px-3 py-1 text-left"
          >
            {{ lang }}
          </router-link>
        </li>
      </ul>

      <div>
        <a
          class="block px-3 py-1"
          target="_blank"
          href="https://weblate.framasoft.org/projects/mobilizon/search-index/"
        >
          Translate
        </a>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
  import { computed, ref } from 'vue'
  import { useGettext } from 'vue3-gettext'

  const showMenu = ref(false)
  const availableLanguages = computed<{ [id: string]: string }>(() => {
    const { available } = useGettext()

    return available
  })

  function toggleShow(): void {
    showMenu.value = !showMenu.value
  }
</script>
